﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UriTemplateSample
{
    class Program
    {
        static void Main(string[] args)
        {
            // Establish our scheme/authority for later matching.
            Uri authority = new Uri("http://www.acme.com");

            // Create our template.
            UriTemplate templateUri = new UriTemplate("Products/{family}/{model}/{number}");

            // Create (simulate) the incoming URI.
            Uri incomingUri = new Uri("http://localhost/Products/Eludium/Q/36");

            // Match the incoming URI to the template.
            UriTemplateMatch matchResults = templateUri.Match(authority, incomingUri);

            // Report to user.
            string report = String.Format("UriTemplate: Matching {0} to {1}\n", incomingUri.ToString(), templateUri.ToString());
            Console.WriteLine(report);

            // See if we matched.
            if (null != matchResults)
            {
                // We matched, so show results.
                foreach (string key in matchResults.BoundVariables.Keys)
                {
                    string match = String.Format(" {0}: {1}", key, matchResults.BoundVariables[key]);
                    Console.WriteLine(match);
                }
            }
            else
            {
                // We did not match.
                Console.WriteLine("The incoming URI did not match.");
            }

            Console.Write("\nPress <enter> to exit.");
            Console.ReadLine();
        }
    }
}
