﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.ServiceModel.Web;
using PhotoShared;
using System.ServiceModel.Activation;
using System.Web;

namespace PhotoWeb
{
    // NOTE: If you change the class name "JsonImageManager" here, you must also update the reference to "JsonImageManager" in Web.config.
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Required)]
    public class JsonImageManager : IImageManager
    {
        ImageManager _imageManager = new ImageManager();

        public virtual string SayHi(string name)
        {
            return _imageManager.SayHi(name);
        }

        [WebInvoke(Method = "POST")]
        public virtual Guid AddImage(ImageItem item)
        {
            return _imageManager.AddImage(item);
        }

        [WebInvoke(Method = "POST")]
        public virtual void DeleteImage(string imageId)
        {
            _imageManager.DeleteImage(imageId);
        }

        [WebInvoke(Method = "POST")]
        public virtual ImageItem GetImage(string imageId)
        {
            return _imageManager.GetImage(imageId);
        }

        [WebInvoke(Method="POST", BodyStyle=WebMessageBodyStyle.WrappedRequest)]
        public virtual ImageItem[] GetImagesForUser(string username)
        {
            return _imageManager.GetImagesForUser(username);
        }

        [WebInvoke(Method = "POST")]
        public virtual void UpdateImage(ImageItem item, string imageId)
        {
            _imageManager.UpdateImage(item, imageId);
        }
    }
}
