﻿var PhotoWebAjax = {
    Delete: function(divId) {
        var imgMgr = new www.scottseely.com.RESTBook._2008.IImageManager();
        imgMgr.DeleteImage(divId,
            function(result, context) {
                var theDiv = document.getElementById(divId);
                theDiv.parentNode.removeChild(theDiv);
            },
             function(response, context) {
                 alert("Failed to delete image ID " + divId +
                     ".\r\n Reason: " + response.get_message());
             });
    },

    LookupImages: function(lstId, divId) {
        var userId = document.getElementById(lstId);
        var showDeleteBar = true;
        if (userId == undefined) {
            userId = "@self";
        }
        else {
            userId = userId.value;
            showDeleteBar = false;
        }
        www.scottseely.com.RESTBook._2008.IImageManager.GetImagesForUser(userId,
            function(result, context) {
                var div = document.getElementById(context);
                var htmlText = "";

                for (var i = 0; i < result.length; ++i) {
                    var imgSrc = result[i].ImageUrl;
                    var caption = result[i].Caption || "";
                    var description = result[i].Description || "";
                    var imageId = result[i].ImageId || "";
                    var publicImage = result[i].PublicImage || "false";
                    var deleteBar = showDeleteBar ?
                        "<div class='Delete' onclick=\"PhotoWebAjax.Delete('" + imageId +
                        "');\" >X</div>" : "";
                    htmlText += "<div class='imageItem' id='" + imageId + "'>" +
                                deleteBar + "<div onclick='PhotoWebAjax.ShowDialog(\"" +
                                imageId + "\");' ><img class='actualImage' src='" +
                                imgSrc + "' alt='" +
                                caption + "' /><input type='hidden' value='" + description + "'/>" +
                                "<input type='hidden' value='" + publicImage + "'/><p>" + caption +
                                "</p></div></div>";
                }

                div.innerHTML = htmlText;
            },
            function(response, context) {
                var div = document.getElementById(context);
                div.innerHTML = "Failed to get images for " + userId +
                    ". <p>Reason: " + response.get_message() + "</p>";
            },
            divId);
    },

    SaveData: function() {
        var txtId = document.getElementById("txtId").value;
        var imageItem = new www.scottseely.com.RESTBook._2008.ImageItem();
        imageItem.Caption = document.getElementById("txtCaption").value;
        imageItem.Description = document.getElementById("txtDescription").value;
        imageItem.PublicImage = document.getElementById("chkPublicImage").checked;
        var dialogContainer = document.getElementById("dialogContainer");
        var theDiv = document.getElementById(txtId);
        var imgMgr = new www.scottseely.com.RESTBook._2008.IImageManager();
        theDiv.getElementsByTagName("p")[0].innerHTML = imageItem.Caption;
        var img = theDiv.getElementsByTagName("img");
        img[0].alt = imageItem.Caption;
        var hiddenFields = theDiv.getElementsByTagName("input");
        if (hiddenFields.length == 2) {
            hiddenFields[0].value = imageItem.Description;
            hiddenFields[1].value = imageItem.PublicImage;
        }
        if (imgMgr != undefined) {
            imgMgr.UpdateImage(imageItem, txtId,
                function() {
                    $('#dialog').dialog('close');
                },
                 function(response, context) {
                     alert("Failed to update image ID " + divId +
                         ".\r\n Reason: " + response.get_message());
                 });
        }
    },

    ShowDialog: function(divId) {
        var dialogContainer = document.getElementById("dialogContainer");
        var theDiv = document.getElementById(divId);
        var img = theDiv.getElementsByTagName("img");
        var caption = img[0].alt;
        var description = theDiv.getElementsByTagName("input")[0].value;
        var publicImage = theDiv.getElementsByTagName("input")[1].value == "true" ? "CHECKED" : "";
        var myDialog = document.getElementById("dialog");
        if (myDialog != undefined) {
            myDialog.parentNode.removeChild(myDialog);
        }
        dialogContainer.innerHTML =
    "<div id=\"dialog\">" +
            "<input type='hidden' value='" + divId + "' id='txtId'/>" +
            "<p><span class=\"dialogLabel\">Caption</span><input type=\"text\" id=\"txtCaption\" value=\"" + caption + "\"/></p>" +
            "<p><span class=\"dialogLabel\">Description</span><input type=\"text\" id=\"txtDescription\" value='" + description + "' /></p>" +
            "<p>Public Image <input id=\"chkPublicImage\" type=\"checkbox\" " + publicImage + " />" +
            "<p><input type=\"button\" value=\"OK\" onclick=\"PhotoWebAjax.SaveData();\"/><input type=\"button\" onclick=\"$('#dialog').dialog('close')\" value=\"Cancel\" /> </p>" +
    "</div>";

        $("#dialog").dialog({
            modal: true,
            overlay: {
                opacity: 0.6,
                background: "black"
            }
        });
    }
};


{"d":[
    {"__type":"ImageItem:http:\/\/www.scottseely.com\/RESTBook\/2008",
     "Caption":"My wonderful wife, Jean",
     "Description":"I love this lady!",
     "ImageBytes":null,
     "ImageId":"16e81e22-9c9e-451f-b804-83ff59c22d3",
     "ImageUrl":"http:\/\/localhost\/PhotoWebCh4\/ImageHandler.ashx\/16e81e22-9c9e-451f-b804-283ff59c22d3",
     "PublicImage":true,
     "UserName":"sseely1"},
     
     {"__type":"ImageItem:http:\/\/www.scottseely.com\/RESTBook\/2008",
     "Caption":"4 generations of family",
     "Description":"Jean, Dzadza, Grandpa, Grandma, Aunt Laurie, Dad, Phil, Angie, Vince",
     "ImageBytes":null,
     "ImageId":"4a4aff8b-967d-488e-90e7-fcb6e0f73fef",
     "ImageUrl":"http:\/\/localhost\/PhotoWebCh4\/ImageHandler.ashx\/4a4aff8b-967d-488e-90e7-fcb6e0f73fef",
     "PublicImage":true,
     "UserName":"sseely1"}
     ]
};
