﻿// [Book name], ISBN: [isbn]
// Kenn Scribner and Scott Seely
// This code supplied without any warranties, express or implied. 
// Code is free to use, public domain. 
// Have a nice day!

using System;
using System.Diagnostics;
using System.Runtime.Serialization;

namespace RESTExtensions
{
    [DataContract(Namespace = "http://www.endurasoft.com/REST.NET/")]
    class ProcessInfo
    {
        public ProcessInfo() :
            this(Process.GetCurrentProcess().Id)
        {
        }

        public ProcessInfo(int processId)
        {
            Process process = Process.GetProcessById(processId);
            BasePriority = process.BasePriority;
            HandleCount = process.HandleCount;
            Id = process.Id;
            MachineName = process.MachineName.CompareTo(".") == 0 ? Environment.MachineName : process.MachineName;
            MainWindowTitle = process.MainWindowTitle;
            NonpagedSystemMemorySize64 = process.NonpagedSystemMemorySize64;
            PagedMemorySize64 = process.PagedMemorySize64;
            PeakPagedMemorySize64 = process.PeakPagedMemorySize64;
            PeakVirtualMemorySize64 = process.PeakVirtualMemorySize64;
            PeakWorkingSet64 = process.PeakWorkingSet64;
            PrivateMemorySize64 = process.PrivateMemorySize64;
            ProcessName = process.ProcessName;
            Responding = process.Responding;
            SessionId = process.SessionId;
            VirtualMemorySize64 = process.VirtualMemorySize64;
            WorkingSet64 = process.WorkingSet64;
        }

        [DataMember]
        public int BasePriority { get; set; }

        [DataMember]
        public int HandleCount { get; set; }

        [DataMember]
        public int Id { get; set; }

        [DataMember]
        public string MachineName { get; set; }

        [DataMember]
        public string MainWindowTitle { get; set; }

        [DataMember]
        public long NonpagedSystemMemorySize64 { get; set; }

        [DataMember]
        public long PagedMemorySize64 { get; set; }

        [DataMember]
        public long PagedSystemMemorySize64 { get; set; }

        [DataMember]
        public long PeakPagedMemorySize64 { get; set; }

        [DataMember]
        public long PeakVirtualMemorySize64 { get; set; }

        [DataMember]
        public long PeakWorkingSet64 { get; set; }

        [DataMember]
        public bool PriorityBoostEnabled { get; set; }

        [DataMember]
        public long PrivateMemorySize64 { get; set; }

        [DataMember]
        public string ProcessName { get; set; }

        [DataMember]
        public bool Responding { get; set; }

        [DataMember]
        public int SessionId { get; set; }

        [DataMember]
        public long VirtualMemorySize64 { get; set; }

        [DataMember]
        public long WorkingSet64 { get; set; }
    }
}
