﻿using System;
using System.Diagnostics;
using System.Runtime.Serialization;
using System.Web;

namespace AspNetRestService
{
    [DataContract(Namespace = "http://www.endurasoft.com/REST.NET/")]
    public sealed class BlogEntryItem
    {
        public BlogEntryItem()
        {
        }

        public BlogEntryItem(Int32 entryID, string title, string entry, DateTime postDate, BlogCommentItem[] comments)
        {
            // Store the basic information
            this.EntryID = entryID;
            this.Title = title;
            this.Entry = entry;
            this.PostDate = postDate;
            this.Comments = comments;

            // Generate the link (remember HATEOAS)
            HttpRequest request = HttpContext.Current.Request;
            string fullUrl = request.Url.ToString();
            string baseUrl = fullUrl.Substring(0, fullUrl.IndexOf(
                request.ApplicationPath));
            this.EntryLink = String.Format("{0}{1}/Default.aspx?BlogID={2}", baseUrl, request.ApplicationPath, entryID);
        }

        public BlogEntryItem(BlogEntry entry, BlogCommentItem[] comments) :
            this(entry.EntryID, entry.Title, entry.Entry, entry.PostDate, comments)
        {
        }

        [DataMember()]
        public Int32 EntryID { get; set; }

        [DataMember()]
        public string Title { get; set; }

        [DataMember()]
        public string Entry { get; set; }

        [DataMember(IsRequired = false)]
        public string EntryLink { get; set; }

        [DataMember()]
        public DateTime PostDate { get; set; }

        [DataMember(IsRequired = false)]
        public BlogCommentItem[] Comments { get; set; }
    }
}
