﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace AspNetRestService
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                // Find and bind the latest blog entry
                BindLatest();
            }
            else
            {
                // Pull the desired blog ID
                string blogIDString = Request.QueryString["BlogID"];
                Int32 blogID = 1;
                if (!String.IsNullOrEmpty(blogIDString) && Int32.TryParse(blogIDString, out blogID))
                {
                    // Bind requested ID
                    BindRequested(blogID);
                }
                else
                {
                    EntryTitle.Text = "Error Locating Blog Entry Selection";
                    Entry.Text = "Sorry, but your blog request is improperly formed. Please try again using a correctly formed request.";
                }
            }
        }

        private void BindLatest()
        {
            // Bind the latest blog entry
            BlogDataClassesDataContext context = new BlogDataClassesDataContext();
            var blogQuery = from b in context.BlogEntries.Take(1) orderby b.PostDate select b;
            EntryTitle.Text = blogQuery.First().Title;
            EntryPostDate.Text = blogQuery.First().PostDate.ToString("MM/dd/yyyy");
            Entry.Text = blogQuery.First().Entry;

            // Bind the comments
            var commentQuery = from c in context.BlogComments where c.EntryID == blogQuery.First().EntryID select c;
            CommentList.DataSource = commentQuery.ToList();
            CommentList.DataBind();
        }

        private void BindRequested(Int32 blogID)
        {
            // Bind the blog entry
            BlogDataClassesDataContext context = new BlogDataClassesDataContext();
            var blogQuery = from b in context.BlogEntries where b.EntryID == blogID select b;
            EntryTitle.Text = blogQuery.First().Title;
            EntryPostDate.Text = blogQuery.First().PostDate.ToString("MM/dd/yyyy");
            Entry.Text = blogQuery.First().Entry;

            // Bind the comments
            var commentQuery = from c in context.BlogComments where c.EntryID == blogID select c;
            CommentList.DataSource = commentQuery.ToList();
            CommentList.DataBind();
        }
    }
}
