﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace WpfClientApplication
{
    /// <summary>
    /// Interaction logic for NewBlogEntryWindow.xaml
    /// </summary>
    public partial class NewBlogEntryWindow : Window
    {
        BlogEntryItem _entryItem = null;
        BlogCommentItem _commentItem = null;
        Int32 _blogID = -1;

        public NewBlogEntryWindow()
        {
            InitializeComponent();
        }

        private void cmdOK_Click(object sender, RoutedEventArgs e)
        {
            // Create a new item
            if (BlogID < 0)
            {
                // Create a blog entry
                _entryItem = new BlogEntryItem();
                _entryItem.Title = tbTitle.Text;
                _entryItem.Entry = tbEntry.Text;
                _entryItem.EntryID = BlogID.ToString();
                _entryItem.PostDate = DateTime.Now;
            }
            else
            {
                // Create a blog comment
                _commentItem = new BlogCommentItem();
                _commentItem.Commentor = tbTitle.Text;
                _commentItem.Comment = tbEntry.Text;
                _commentItem.EntryID = BlogID.ToString();
                _commentItem.CommentID = "0";
                _commentItem.PostDate = DateTime.Now;
            }

            // Return OK
            this.DialogResult = true;
        }

        public BlogEntryItem EntryItem
        {
            get { return _entryItem; }
        }

        public BlogCommentItem CommentItem
        {
            get { return _commentItem; }
        }

        public Int32 BlogID
        {
            get { return _blogID; }
            set
            {
                // Save blog ID
                _blogID = value;

                // With a blog ID, we know we're going to create
                // a comment, so change label accordingly.
                lblTitle.Content = "Commentor:";
                lblEntry.Content = "Comment content:";
            }
        }
    }
}
