﻿using System;
using System.Web;
using System.Web.Mvc;

namespace AspNetMvcRestService.Models
{
    public static class CodeXRCLinkBuilder
    {
        public static string BuildProjectLink(ControllerContext context, string projectName)
        {
            // Generate the link (remember HATEOAS)
            string fullUrl = context.HttpContext.Request.Url.ToString();
            string baseUrl = fullUrl.Substring(0, fullUrl.IndexOf(
                context.HttpContext.Request.ApplicationPath));
            return String.Format("{0}{1}/CodeXRC/{2}", baseUrl, context.HttpContext.Request.ApplicationPath, projectName);
        }

        public static string BuildFolderLink(ControllerContext context, string projectName, string folderName)
        {
            // Generate the link (remember HATEOAS)
            string fullUrl = context.HttpContext.Request.Url.ToString();
            string baseUrl = fullUrl.Substring(0, fullUrl.IndexOf(
                context.HttpContext.Request.ApplicationPath));
            return String.Format("{0}{1}/CodeXRC/{2}/{3}", baseUrl, context.HttpContext.Request.ApplicationPath, projectName, folderName);
        }

        public static string BuildFileLink(ControllerContext context, string projectName, string folderName, string fileExtension, string fileName)
        {
            // Generate the link (remember HATEOAS)
            string fullUrl = context.HttpContext.Request.Url.ToString();
            string baseUrl = fullUrl.Substring(0, fullUrl.IndexOf(
                context.HttpContext.Request.ApplicationPath));
            return String.Format("{0}{1}/CodeXRC/{2}/{3}/{4}/{5}", baseUrl, context.HttpContext.Request.ApplicationPath, projectName, folderName, fileExtension, fileName);
        }
    }
}
