﻿using System;
using System.Diagnostics;
using System.Runtime.Serialization;
using System.Web;

namespace AspNetMvcRestService.Models
{
    [DataContract(Namespace = "http://www.endurasoft.com/REST.NET/", Name = "File")]
    public sealed class FileDTO
    {
        public FileDTO()
        {
        }

        public FileDTO(File dbFile) :
            this()
        {
            // Copy properties
            this.FileID = dbFile.FileID;
            this.FolderID = dbFile.FolderID;
            this.ProjectID = dbFile.ProjectID;
            this.DisplayName = dbFile.DisplayName;
            this.LocalStorage = dbFile.LocalStorage;
        }

        public FileDTO(File dbFile, string contents) :
            this(dbFile)
        {
            // Save contents
            this.Contents = contents;
        }

        [DataMember]
        public Int32 FileID { get; set; }

        [DataMember]
        public Int32 FolderID { get; set; }

        [DataMember]
        public Int32 ProjectID { get; set; }

        [DataMember]
        public string DisplayName { get; set; }

        [DataMember(IsRequired = false)]
        public string Link { get; set; }

        [DataMember]
        public string Contents { get; set; }

        public string LocalStorage { get; set; }
    }
}
