﻿using System;
using System.Diagnostics;
using System.Runtime.Serialization;
using System.Web;

namespace AspNetMvcRestService.Models
{
    [DataContract(Namespace = "http://www.endurasoft.com/REST.NET/", Name = "Folder")]
    public class FolderDTO
    {
        public FolderDTO()
        {
        }

        public FolderDTO(Folder dbFolder) :
            this()
        {
            // Copy properties
            this.FolderID = dbFolder.FolderID;
            this.ParentFolderID = dbFolder.ParentFolderID;
            this.ProjectID = dbFolder.ProjectID;
            this.DisplayName = dbFolder.DisplayName;
        }

        public FolderDTO(Folder dbFolder, FolderDTO[] folders, FileDTO[] files) :
            this(dbFolder)
        {
            // Copy folders
            this.Folders = folders;

            // Copy files
            this.Files = files;
        }

        [DataMember]
        public Int32 FolderID { get; set; }

        [DataMember]
        public Int32 ParentFolderID { get; set; }

        [DataMember]
        public Int32 ProjectID { get; set; }

        [DataMember]
        public string DisplayName { get; set; }

        [DataMember(IsRequired = false)]
        public string Link { get; set; }

        [DataMember(IsRequired = false)]
        public FolderDTO[] Folders { get; set; }

        [DataMember(IsRequired = false)]
        public FileDTO[] Files { get; set; }
    }
}
