﻿using System;
using System.Diagnostics;
using System.Runtime.Serialization;
using System.Web;

namespace AspNetMvcRestService.Models
{
    [DataContract(Namespace = "http://www.endurasoft.com/REST.NET/", Name="Project")]
    public class ProjectDTO
    {
        public ProjectDTO()
        {
        }

        public ProjectDTO(Project dbProject) :
            this()
        {
            // Copy properties
            this.ProjectID = dbProject.ProjectID;
            this.DisplayName = dbProject.DisplayName;
        }

        public ProjectDTO(Project dbProject, FolderDTO[] folders) :
            this(dbProject)
        {
            // Copy folders
            this.Folders = folders;
        }

        [DataMember]
        public Int32 ProjectID { get; set; }

        [DataMember]
        public string DisplayName { get; set; }

        [DataMember(IsRequired = false)]
        public string Link { get; set; }

        [DataMember(IsRequired = false)]
        public FolderDTO[] Folders { get; set; }
    }
}
