﻿using System;
using System.Diagnostics;
using System.Runtime.Serialization;
using System.Web;

/// <remarks>
/// I derived this class as I would any class coming from a RESTful
/// service that I knew would be updated via XML. I took a copy of
/// the XML from the service and ran it through xsd.exe to create
/// a schema. With the schema in hand, I ran xsd.exe again to create
/// a C# file.
/// 
/// Then it got interesting. The C# file you get is tailored for
/// the XML Serializer, but here I wanted to use the runtime XML
/// serialializer to make sure the XML would match. I found I also
/// then had to flex the server side a bit to make some of the
/// properties optional (or marked as optional...they always were
/// intended to be issued to the client, not client to service). 
/// </remarks>
[DataContract(Namespace = "http://www.endurasoft.com/REST.NET/", Name="File")]
public partial class LocalFileDTO
{

    private string fileIDField;

    private string folderIDField;

    private string projectIDField;

    private string displayNameField;

    private string linkField;

    private string contentsField;

    /// <remarks/>
    [DataMember]
    public string FileID
    {
        get
        {
            return this.fileIDField;
        }
        set
        {
            this.fileIDField = value;
        }
    }

    /// <remarks/>
    [DataMember]
    public string FolderID
    {
        get
        {
            return this.folderIDField;
        }
        set
        {
            this.folderIDField = value;
        }
    }

    /// <remarks/>
    [DataMember]
    public string ProjectID
    {
        get
        {
            return this.projectIDField;
        }
        set
        {
            this.projectIDField = value;
        }
    }

    /// <remarks/>
    [DataMember]
    public string DisplayName
    {
        get
        {
            return this.displayNameField;
        }
        set
        {
            this.displayNameField = value;
        }
    }

    /// <remarks/>
    [DataMember]
    public string Link
    {
        get
        {
            return this.linkField;
        }
        set
        {
            this.linkField = value;
        }
    }

    /// <remarks/>
    [DataMember]
    public string Contents
    {
        get
        {
            return this.contentsField;
        }
        set
        {
            this.contentsField = value;
        }
    }
}

