﻿// Effective REST Services via .NET, ISBN: 0321613406
// Kenn Scribner and Scott Seely
// This code supplied without any warranties, express or implied. 
// Code is free to use, public domain. 
// Have a nice day!
using System;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Services;

namespace PhotoWeb
{
    /// <summary>
    /// Summary description for $codebehindclassname$
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    public class ImageHandler : IHttpHandler
    {
        public void ProcessRequest(HttpContext context)
        {
            Guid imageId = Guid.Empty;
            byte[] responseBytes = null;
            if (Utility.TryParse(context.Request.Url.Segments[context.Request.Url.Segments.Length - 1],
                out imageId))
            {
                using (PhotoWebDbDataContext dataContext = new PhotoWebDbDataContext())
                {
                    var images = from image in dataContext.Images
                                 where image.ImageId == imageId
                                 select image.ImageBytes;
                    foreach (var image in images)
                    {
                        responseBytes = image.ToArray();
                        break;
                    }
                }
            }
            if (responseBytes == null)
            {
                context.Response.StatusCode = (int)HttpStatusCode.NotFound;
            }
            else
            {
                context.Response.ContentType = "image/jpeg";
                context.Response.OutputStream.Write(responseBytes, 0, responseBytes.Length);
                context.Response.OutputStream.Close();
            }
        }

        public bool IsReusable
        {
            get
            {
                return true;
            }
        }
    }
}
