﻿using System;
using System.Diagnostics;
using System.Runtime.Serialization;
using System.Web;

using CommentSvc.DAL;

namespace CommentSvc.Model
{
    [DataContract(Namespace = "http://www.endurasoft.com/REST.NET/", Name = "Contact")]
    public sealed class CommentDTO
    {
        public CommentDTO()
        {
        }

        public CommentDTO(Int32 commentID, string name, string email, string comment)
        {
            // Store the basic information
            this.CommentID = commentID;
            this.Name = name;
            this.EMail = email;
            this.Comment = comment;
        }

        public CommentDTO(Comment comment) :
            this(comment.CommentID, comment.Name, comment.EMail, comment.CommentText)
        {
        }

        [DataMember()]
        public Int32 CommentID { get; set; }

        [DataMember(IsRequired = false)]
        public string Name { get; set; }

        [DataMember(IsRequired = false)]
        public string EMail { get; set; }

        [DataMember(IsRequired = false)]
        public string Link { get; set; }

        [DataMember()]
        public string Comment { get; set; }
    }
}
