﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.ServiceModel.Description;
using System.Windows.Forms;
using Microsoft.ServiceBus;

namespace CommentSvc
{
    class Program
    {
        static void Main(string[] args)
        {
            // Request credentials
            LoginForm dlg = new LoginForm();
            if (dlg.ShowDialog() != DialogResult.OK) return;

            // Create the Azure URI for the service
            Uri address = new Uri(String.Format("http://{0}/services/{1}/CommentService/",
                ServiceBusEnvironment.DefaultRelayHostName, dlg.Username));

            // Establish the endpoint credentials using the username
            // and password provided (we could use CardSpace by omitting
            // this behavior entirely).
            TransportClientEndpointBehavior behavior = new TransportClientEndpointBehavior();
            behavior.CredentialType = TransportClientCredentialType.UserNamePassword;
            behavior.Credentials.UserName.UserName = dlg.Username;
            behavior.Credentials.UserName.Password = dlg.Password;

            // Create the host and apply the endpoint behavior
            WebServiceHost host = new WebServiceHost(typeof(CommentService), address);
            host.Description.Endpoints[0].Behaviors.Add(behavior);
            host.Open();

            // Print a banner
            Console.WriteLine("Copy the following address into a browser to see the response: ");
            Console.WriteLine("{0}Comments", address);
            Console.WriteLine();
            Console.WriteLine("Press any key to exit...");
            Console.ReadKey();

            // Close the connection
            host.Close();
        }
    }
}
