﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using Microsoft.ServiceBus.Web;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.ServiceModel.Channels;
using System.Text;
using System.IO;

using CommentSvc.Model;

namespace CommentSvc
{
    [ServiceContract]
    public interface ICommentService
    {
        [OperationContract(ReplyAction = "GETALLRESPONSE")]
        [WebGet(UriTemplate = "/Comments",
            BodyStyle = WebMessageBodyStyle.Bare)]
        Message GetAllComments();

        [OperationContract(ReplyAction = "GETRESPONSE")]
        [WebGet(UriTemplate = "/Comments/{CommentID}",
            BodyStyle = WebMessageBodyStyle.Bare)]
        Message GetComment(string commentID);

        [OperationContract(ReplyAction = "POSTRESPONSE")]
        [WebInvoke(Method = "POST", UriTemplate = "/Comments",
            BodyStyle = WebMessageBodyStyle.Bare,
            RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml)]
        Message SaveComment(CommentDTO item);
    }
}
